/*
 * Copyright (C): Timo Fleisch
 *                2009 Berlin, Germany
 *                http://www.vrhome.de
 *                All Rights Reserved.
 *
 * THIS SOURCECODE IS PUBLISHED UNDER RESTRICTIONS.
 * No unauthorized copy or distribution allowed.
 * Please see website for detailed liscence information.
 * 
 */
using System;
using System.Collections.Generic;
using System.Text;

namespace Tgex
{
    public class EqualCondition : ICondition
    {
        Property prop1;
        Property prop2;
        int parameterCount;

        public EqualCondition(Property prop1, Property prop2)
        {
            if (prop1.GetType() != prop2.GetType())
            {
                throw new Exception("Both properties have to be of same type.");
            }
            this.prop1 = prop1;
            this.prop2 = prop2;
            parameterCount = 2;
        }
        public EqualCondition()
        {
            parameterCount = 0;
        }
        public void AddParameter(InstanceParameter par)
        {
            if (parameterCount == 0)
            {
                prop1 = (Property)par.value;
                parameterCount++;
            }
            else if (parameterCount == 1)
            {
                prop2 = (Property)par.value;
                parameterCount++;
            }
        }
        public bool CheckCondition()
        {
            if (parameterCount != 2) return false;
            return (prop1.GetValue() == prop2.GetValue());
        }
    }
}
