﻿/*
 * Copyright (C): Timo Fleisch
 *                2009 Berlin, Germany
 *                http://www.vrhome.de
 *                All Rights Reserved.
 *
 * THIS SOURCECODE IS PUBLISHED UNDER RESTRICTIONS.
 * No unauthorized copy or distribution allowed.
 * Please see website for detailed liscence information.
 * 
 */
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework;

namespace Tgex
{
    public static class Extensions
    {
        public static Vector3 TryParse(this Vector3 point, String value)
        {
            System.Globalization.NumberFormatInfo nfi
                = System.Globalization.CultureInfo.InvariantCulture.NumberFormat;
            String[] values = value.Split(',');
            point = new Vector3();
            try
            {
                point.X = float.Parse(values[0], nfi);
                point.Y = float.Parse(values[1], nfi);
                point.Z = float.Parse(values[2], nfi);
            }
            catch
            {
            }
            return point;
        }
        public static Vector3 ParseVector3(this String value)
        {
            System.Globalization.NumberFormatInfo nfi
                = System.Globalization.CultureInfo.InvariantCulture.NumberFormat;
            String[] values = value.Split(',');
            Vector3 point = new Vector3();
            try
            {
                point.X = float.Parse(values[0], nfi);
                point.Y = float.Parse(values[1], nfi);
                point.Z = float.Parse(values[2], nfi);
            }
            catch
            {
                ErrorHandler.Report("Error parsing vector3");
            }
            return point;
        }
        public static Vector2 ParseVector2(this String value)
        {
            System.Globalization.NumberFormatInfo nfi
                = System.Globalization.CultureInfo.InvariantCulture.NumberFormat;
            String[] values = value.Split(',');
            Vector2 point = new Vector2();
            try
            {
                point.X = float.Parse(values[0], nfi);
                point.Y = float.Parse(values[1], nfi);
            }
            catch
            {
                ErrorHandler.Report("Error parsing vector2");
            }
            return point;
        }
        public static float Between(this Random random, float min, float max)
        {
            return min + (float)random.NextDouble() * (max - min);
        }

        public static float DistanceToLine(this Vector2 point,
            Vector2 startLinePoint, Vector2 endLinePoint, out float lamda)
        {
            // test if onLinePoint is on the line defined by start and end point
            // do that by calculating distance
            // according to: http://mathenexus.zum.de/html/geometrie/abstaende/AbstandPG.htm
            Vector2 rv = endLinePoint - startLinePoint;

            Vector2 p_ap = point - startLinePoint;
            float dot_rv = Vector2.Dot(rv, rv);
            lamda = Vector2.Dot(p_ap, (rv / dot_rv));

            Vector2 distVec = point - (startLinePoint +
                lamda * rv);

            return distVec.Length();
        }
    }
}
