﻿/*
 * Copyright (C): Timo Fleisch
 *                2009 Berlin, Germany
 *                http://www.vrhome.de
 *                All Rights Reserved.
 *
 * THIS SOURCECODE IS PUBLISHED UNDER RESTRICTIONS.
 * No unauthorized copy or distribution allowed.
 * Please see website for detailed liscence information.
 * 
 */
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Xml;
using System.Runtime;
using Microsoft.Xna.Framework.Storage;
using System.IO;

namespace Tgex
{
    public class GameDataLoader
    {
        public GameDataLoader()
        {
        }

        public void LoadGameData(String filename)
        {
            string fullPath = Path.Combine(StorageContainer.TitleLocation, filename);
            XmlDocument xmlFile = new XmlDocument();
            xmlFile.Load(fullPath);
            // load globals
            XmlNodeList global = xmlFile.GetElementsByTagName("Global");
            XmlNodeList globalChilds = global.Item(0).ChildNodes;
            foreach (XmlNode child in globalChilds)
            {
                if (child.Name == "PropertyList")
                {
                    XmlNodeList globalProperties = child.ChildNodes;
                    foreach (XmlNode propertyNode in globalProperties)
                    {
                        String typeString = "Tgex." + propertyNode.Attributes.GetNamedItem("class").Value;
                        Type t = Type.GetType(typeString);
                        if (t != null)
                        {
                            Property p = (Property)Activator.CreateInstance(t);
                            p.Parse(propertyNode);
                            GlobalProperties.Instance.
                                AddProperty(p);
                        }
                    }
                }
            }

            // load dynobs
            XmlNodeList dynobs = xmlFile.GetElementsByTagName("Dynob");
            foreach (XmlNode dynob in dynobs)
            {
                DynobFactory.Instance.AddBlueprint((XmlElement)dynob);
            }
        }
    }
}
