using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Content;

namespace VRhomeLib.Menu
{
    public class MenuPage
    {
        SpriteAnimationModule m_menuSprite;
        List<MenuPage> m_subPageList;
        int m_selectedSubPage;
        MenuPage previousPage;

        public MenuPage()
        {
            m_menuSprite = new SpriteAnimationModule();

        }

        // each sub page must have its own sprite texture that is displayed
        // when subpage is selected.
        public void AddSubPage(MenuPage subPage, String subPageSelectedTexture,
            ContentManager contentManager)
        {
            m_menuSprite.AddTexture(subPageSelectedTexture, contentManager);
            m_subPageList.Add(subPage);
        }

        void SelectSubPage(int index)
        {
            if (index < m_subPageList.Count)
            {
                m_selectedSubPage = index;
                m_menuSprite.SelectTexture(index);
            }
        }
        
        public virtual MenuPage Update(GameTime time)
        {
            m_menuSprite.Update(time);

            return this;
        }

        public void InitVisualization(GraphicsDeviceManager graphics)
        {
            m_menuSprite.InitVisualization(graphics);
            foreach (MenuPage subPage in m_subPageList)
            {
                subPage.InitVisualization(graphics);
            }
        }

        public void Draw(GraphicsDeviceManager graphics)
        {
            m_menuSprite.Draw(graphics);
        }
    }
}
