/*
 * Copyright (C): Timo Fleisch
 *                2009 Berlin, Germany
 *                http://www.vrhome.de
 *                All Rights Reserved.
 *
 * THIS SOURCECODE IS PUBLISHED UNDER RESTRICTIONS.
 * No unauthorized copy or distribution allowed.
 * Please see website for detailed liscence information.
 * 
 */
using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Input;

namespace Tgex
{
    public class ControllerMovement : Modifier
    {
        Vector2Property m_position;
        float m_xStep;
        float m_yStep;

        // default hd
        private float m_ScreenRatio = 1.777777f;

        public float ScreenRatio
        {
            get { return m_ScreenRatio; }
            set { m_ScreenRatio = value; }
        }

        public override void Update(GameTime time)
        {
            m_yStep = m_xStep * m_ScreenRatio;
            Vector2 position = m_position.Value;
            float timeFactor = (float)(time.ElapsedGameTime.TotalMilliseconds) / 15.0f;
            if (Keyboard.GetState().IsKeyDown(Keys.Left))
                position.X -= m_xStep;
            if (Keyboard.GetState().IsKeyDown(Keys.Right))
                position.X += m_xStep;
            if (Keyboard.GetState().IsKeyDown(Keys.Up))
                position.Y -= m_yStep;
            if (Keyboard.GetState().IsKeyDown(Keys.Down))
                position.Y += m_yStep;

#if WINDOWS || XBOX
            if (GamePad.GetState(PlayerIndex.One).ThumbSticks.Left.X != 0)
                position.X += timeFactor * (GamePad.GetState(PlayerIndex.One).ThumbSticks.Left.X / 150);
            if (GamePad.GetState(PlayerIndex.One).ThumbSticks.Left.Y != 0)
                position.Y -= timeFactor * (GamePad.GetState(PlayerIndex.One).ThumbSticks.Left.Y / 150) 
                    * m_ScreenRatio;
#elif ZUNE
            if (GamePad.GetState(PlayerIndex.One).DPad.Left == ButtonState.Pressed)
                position.X -= m_xStep;
            if (GamePad.GetState(PlayerIndex.One).DPad.Right == ButtonState.Pressed)
                position.X += m_xStep;
            if (GamePad.GetState(PlayerIndex.One).DPad.Up == ButtonState.Pressed)
                position.Y -= m_yStep;
            if (GamePad.GetState(PlayerIndex.One).DPad.Down == ButtonState.Pressed)
                position.Y += m_yStep;
#endif
            if (m_position.Value.X < 0.03f) position.X = 0.03f;
            if (m_position.Value.Y < 0.03f) position.Y = 0.03f;
            if (m_position.Value.X > 0.97f) position.X = 0.97f;
            if (m_position.Value.Y > 0.97f) position.Y = 0.97f;

            m_position.Value = position;
        }
        public ControllerMovement()
        {
#if WINDOWS || XBOX
            m_xStep = 0.007f;
#elif ZUNE
            m_xStep = 0.011f;
#endif
        }
        public override void Initialize()
        {
            base.Initialize();
            m_position = (Vector2Property)dynob.GetPropertyByName("position");
        }
        public ControllerMovement(ControllerMovement original)
            : base (original)
        {
            m_xStep = 0.007f;
            m_ScreenRatio = original.ScreenRatio;
        }
        public override Modifier Clone()
        {
            return new ControllerMovement(this);
        }
    }
}
