/*
 * Copyright (C): Timo Fleisch
 *                2009 Berlin, Germany
 *                http://www.vrhome.de
 *                All Rights Reserved.
 *
 * THIS SOURCECODE IS PUBLISHED UNDER RESTRICTIONS.
 * No unauthorized copy or distribution allowed.
 * Please see website for detailed liscence information.
 * 
 */
using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.Xna.Framework;

namespace Tgex
{
    public class FloatModifier : Modifier
    {
        FloatProperty m_speed;
        FloatProperty m_v;
        String m_propertyName;

        public override void Update(GameTime time)
        {
            m_v.Value += (float)(time.ElapsedGameTime.TotalMilliseconds * m_speed.Value);
        }
        public FloatModifier(String propName)
        {
            m_propertyName = propName;
        }
        public FloatModifier()
        {
            m_propertyName = null;
        }
        public FloatModifier(FloatModifier original)
            : base(original)
        {
            m_propertyName = original.m_propertyName;
            m_v = original.m_v;
            m_speed = original.m_speed;
        }
        public override Modifier Clone()
        {
            return new FloatModifier(this);
        }
        public override void Initialize()
        {
            base.Initialize();
            m_speed = (FloatProperty)dynob.GetPropertyByName("rotationSpeed");
            if (m_propertyName != null)
            {
                m_v = (FloatProperty)dynob.GetPropertyByName(m_propertyName);
            }
        }
        public override void AddParameter(InstanceParameter parameter)
        {
            switch (parameter.name)
            {
                case "Active":
                    Active = (bool)parameter.value;
                    AddInitialParameter(parameter);
                    break;
                case "Rotation":
                    m_v = (FloatProperty)parameter.value;
                    break;
            }
        }
    }
}
