/*
 * Copyright (C): Timo Fleisch
 *                2009 Berlin, Germany
 *                http://www.vrhome.de
 *                All Rights Reserved.
 *
 * THIS SOURCECODE IS PUBLISHED UNDER RESTRICTIONS.
 * No unauthorized copy or distribution allowed.
 * Please see website for detailed liscence information.
 * 
 */
using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.Xna.Framework;

namespace Tgex
{
    public class Modifier : IParametrizable
    {
        protected String m_Name;
        /// <summary>
        /// Identifier m_Name for modifier.
        /// </summary>
        public String Name
        {
            get { return m_Name; }
            set { m_Name = value; }
        }
        protected Dynob dynob;

        private bool m_Active = true;

        public bool Active
        {
            get { return m_Active; }
            set { m_Active = value; }
        }

        protected List<InstanceParameter> m_initialParameterList = new List<InstanceParameter>();

        public Modifier()
        {
        }
        public Modifier(Modifier m)
        {
            m_Name = m.m_Name;
            m_Active = m.m_Active;
        }
        public virtual Modifier Clone()
        {
            return new Modifier(this);
        }

        public virtual void AddParameter(InstanceParameter parameter)
        {
        }

        public virtual void Register(Dynob dynob)
        {
            this.dynob = dynob;
        }

        public virtual void Update(GameTime time)
        {
            // empty
        }
        public virtual void OnLoad()
        {
            // empty
        }
        public virtual void Initialize()
        {
            // empty
        }
        public virtual void Reset()
        {
            foreach (InstanceParameter parameter in m_initialParameterList)
            {
                AddParameter(parameter);
            }
        }
        protected void AddInitialParameter(InstanceParameter parameter)
        {
            if (!m_initialParameterList.Exists(p => p.name == parameter.name))
            {
                m_initialParameterList.Add(parameter);
            }
        }
    }
}
