/*
 * Copyright (C): Timo Fleisch
 *                2009 Berlin, Germany
 *                http://www.vrhome.de
 *                All Rights Reserved.
 *
 * THIS SOURCECODE IS PUBLISHED UNDER RESTRICTIONS.
 * No unauthorized copy or distribution allowed.
 * Please see website for detailed liscence information.
 * 
 */
using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.Xna.Framework;

namespace Tgex
{
    public class PathMovement : Modifier
    {
        Vector2Property m_position;
        private Curve2D m_Path = new Curve2D();

        public Curve2D Path
        {
            get { return m_Path; }
            set { m_Path = value; }
        }

        public override void Update(GameTime time)
        {
            m_position.Value = m_Path.GetPointOnCurve((float)time.TotalRealTime.TotalMilliseconds);
        }
        public PathMovement()
        {
            m_Path.SetPreLoop(CurveLoopType.Cycle);
            m_Path.SetPostLoop(CurveLoopType.Cycle);
            float time = 0;
            float timeSpace = 700;
            m_Path.addKey(time, 250, 50);
            time += timeSpace;
            m_Path.addKey(time, 450, 250);
            time += timeSpace;
            m_Path.addKey(time, 250, 450);
            time += timeSpace;
            m_Path.addKey(time, 50, 250);
            time += timeSpace;
            m_Path.addKey(time, 250, 50);
            m_Path.SetTangents();
        }
        public PathMovement(PathMovement original)
            : base(original)
        {
            m_Path = original.Path;
        }
        public override Modifier Clone()
        {
            return new PathMovement(this);
        }
        public override void Initialize()
        {
            base.Initialize();
            m_position = (Vector2Property)dynob.GetPropertyByName("position");
        }
    }
}
