/*
 * Copyright (C): Timo Fleisch
 *                2009 Berlin, Germany
 *                http://www.vrhome.de
 *                All Rights Reserved.
 *
 * THIS SOURCECODE IS PUBLISHED UNDER RESTRICTIONS.
 * No unauthorized copy or distribution allowed.
 * Please see website for detailed liscence information.
 * 
 */
using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.Xna.Framework;
namespace Tgex
{
    public class PhysicMovement : Modifier
    {
        FloatProperty m_speed;
        Vector2Property m_position;
        Vector2Property m_direction;

        public override void Update(GameTime time)
        {
            m_position.Value += ((float)(time.ElapsedGameTime.TotalMilliseconds * m_speed.Value)) 
                * m_direction.Value;
        }
        public PhysicMovement()
        {
        }
        public PhysicMovement(PhysicMovement original)
            : base(original)
        {
        }
        public override Modifier Clone()
        {
            return new PhysicMovement(this);
        }
        public override void Initialize()
        {
            base.Initialize();
            m_speed = (FloatProperty)dynob.GetPropertyByName("speed");
            m_position = (Vector2Property)dynob.GetPropertyByName("position");
            m_direction = (Vector2Property)dynob.GetPropertyByName("direction");
        }
    }
}
