﻿/*
 * Copyright (C): Timo Fleisch
 *                2009 Berlin, Germany
 *                http://www.vrhome.de
 *                All Rights Reserved.
 *
 * THIS SOURCECODE IS PUBLISHED UNDER RESTRICTIONS.
 * No unauthorized copy or distribution allowed.
 * Please see website for detailed liscence information.
 * 
 */
using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Media;
using Microsoft.Xna.Framework;

namespace Tgex
{
    public class MusicModule : SpriteModule
    {
        VisualizationData visData = new VisualizationData();

        public override void Draw(GraphicsDeviceManager graphics)
        {
            // calc size
            viewportSize = new Vector2((float)graphics.GraphicsDevice.Viewport.Width,
                                        (float)graphics.GraphicsDevice.Viewport.Height);
            pixelSize = new Vector2(1 / viewportSize.X, 1 / viewportSize.Y);

            float textureWidth = m_texture.Width * pixelSize.X;
            float textureHeight = m_texture.Height * pixelSize.Y;
            Vector2 origTexSize = new Vector2(m_texture.Width,
                                              m_texture.Height);
            Vector2 curTexSize;
            if (targetSize.X == 0)
            {
                curTexSize = origTexSize;
            }
            else
            {
                curTexSize = targetSize;
            }


            if (m_sprite != null)
            {
                m_sprite.Begin(SpriteBlendMode.AlphaBlend);
                int size = visData.Samples.Count;
                //foreach (float value in visData.Samples)
                for (int i = 0; i < size; i++)
                {
                    if ((i % 10) == 0)
                    {
                        m_spritePosition.X = (i / ((float)size)) * viewportSize.X;
                        m_spritePosition.Y = (1 - visData.Frequencies[i]) * viewportSize.Y;
                        //m_spritePosition.Y = visData.Samples[i] * (viewportSize.Y / 2) + (viewportSize.Y/2);
                        Rectangle rect = new Rectangle();
                        rect.X = (int)m_spritePosition.X;
                        rect.Y = (int)m_spritePosition.Y;
                        rect.Height = (int)curTexSize.X;
                        rect.Width = (int)curTexSize.Y;
                        float angle = 0;
                        //if (spriteRotation != null) angle = spriteRotation.Value;
                        m_sprite.Draw(m_texture, rect, null, Color.White,
                            angle,
                            origTexSize / 2.0f, SpriteEffects.None, 0.1f);
                    }
                }
                m_sprite.End();
            }
        }
        public override void  Update(GameTime time)
        {
            if (MediaPlayer.State == MediaState.Playing)
            {
                MediaPlayer.GetVisualizationData(visData);
            }
 	         base.Update(time);
        }

    }
}
