/*
 * Copyright (C): Timo Fleisch
 *                2009 Berlin, Germany
 *                http://www.vrhome.de
 *                All Rights Reserved.
 *
 * THIS SOURCECODE IS PUBLISHED UNDER RESTRICTIONS.
 * No unauthorized copy or distribution allowed.
 * Please see website for detailed liscence information.
 * 
 */
using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.Xna.Framework;

namespace Tgex
{
    public class ShootModule : Module
    {
        protected Vector2Property position;
        protected FloatProperty shootInterval;
        double timeToNextShot;
        private bool shoot;

        public Vector2 GetPosition()
        {
            return position.Value;
        }

        public bool Shoot
        {
            get { return shoot; }
            set { shoot = value; }
        }
	
        public ShootModule() : base()
        {
            m_Name = "shootModule";
        }
        public override void Initialize()
        {
            base.Initialize();
            position = (Vector2Property)dynob.GetPropertyByName("position");
            shootInterval = (FloatProperty)dynob.GetPropertyByName("shootInterval");
            timeToNextShot = 0;
        }
        public override void OnStart()
        {
            base.OnStart();
            timeToNextShot = 0;
            shoot = false;
        }
        public override void Update(GameTime time)
        {
            base.Update(time);
            timeToNextShot += time.ElapsedGameTime.TotalMilliseconds;
            if (timeToNextShot > shootInterval.Value)
            {
                timeToNextShot = 0;
                shoot = true;
            }
        }
        public override void AddParameter(InstanceParameter parameter)
        {
            if (parameter.name == "Active")
            {
                Active = (bool)parameter.value;
                AddInitialParameter(parameter);
            }
        }
    }
}
