/*
 * Copyright (C): Timo Fleisch
 *                2009 Berlin, Germany
 *                http://www.vrhome.de
 *                All Rights Reserved.
 *
 * THIS SOURCECODE IS PUBLISHED UNDER RESTRICTIONS.
 * No unauthorized copy or distribution allowed.
 * Please see website for detailed liscence information.
 * 
 */
using System;
using System.Collections.Generic;
using System.Text;
using System.Xml;

namespace Tgex
{
    public class BoolProperty : Property
    {
        protected bool m_Value;
        /// <summary>
        /// Bool m_Value of property.
        /// </summary>
        public bool Value
        {
            get { return m_Value; }
            set { m_Value = value; }
        }

        public override object GetValue()
        {
            return m_Value;
        }
        public override void SetValue(object v)
        {
            m_Value = (bool)v;
        }
        protected bool m_InitialValue;
        /// <summary>
        /// Value at start up.
        /// </summary>
        public bool InitialValue
        {
            get { return m_InitialValue; }
            set { m_InitialValue = value; }
        }

        /// <summary>
        /// Constructor
        /// </summary>
        public BoolProperty()
        {
        }
        /// <summary>
        /// Copy constructor
        /// </summary>
        /// <param name="p"></param>
        public BoolProperty(BoolProperty p)
            : base(p)
        {
            m_Value = p.Value;
            m_InitialValue = p.InitialValue;
        }
        public BoolProperty(XmlNode node)
            : base (node)
        {
            m_Value = bool.Parse(node.Attributes.GetNamedItem("value").Value);
            m_InitialValue = m_Value;
        }
        public override void  Parse(XmlNode node)
        {
            base.Parse(node);
            m_Value = bool.Parse(node.Attributes.GetNamedItem("value").Value);
            m_InitialValue = m_Value;
        }

        /// <summary>
        /// Clone BoolProperty
        /// </summary>
        /// <returns></returns>
        public override Property Clone()
        {
            return new BoolProperty(this);
        }
        public override void Reset()
        {
            m_Value = m_InitialValue;
        }
    }
}
