/*
 * Copyright (C): Timo Fleisch
 *                2009 Berlin, Germany
 *                http://www.vrhome.de
 *                All Rights Reserved.
 *
 * THIS SOURCECODE IS PUBLISHED UNDER RESTRICTIONS.
 * No unauthorized copy or distribution allowed.
 * Please see website for detailed liscence information.
 * 
 */
using System;
using System.Collections.Generic;
using System.Text;
using System.Xml;

namespace Tgex
{
    public class FloatProperty : Property
    {
        protected float m_Value;
        /// <summary>
        /// Int m_Value of property.
        /// </summary>
        public float Value
        {
            get { return m_Value; }
            set { m_Value = value; }
        }
        public override object GetValue()
        {
            return m_Value;
        }
        public override void SetValue(object v)
        {
            m_Value = (float)v;
        }
        protected float m_InitialValue;
        /// <summary>
        /// Value at start time.
        /// </summary>
        public float InitialValue
        {
            get { return m_InitialValue; }
            set { m_InitialValue = value; }
        }

        public FloatProperty()
        {
        }
        public FloatProperty(FloatProperty p)
            : base(p)
        {
            m_Value = p.Value;
            m_InitialValue = p.InitialValue;
        }
        public override Property Clone()
        {
            return new FloatProperty(this);
        }
        public FloatProperty(XmlNode node)
            : base(node)
        {
            System.Globalization.NumberFormatInfo nfi
                = System.Globalization.CultureInfo.InvariantCulture.NumberFormat;
            try
            {
                m_Value = float.Parse(node.Attributes.GetNamedItem("value").Value, nfi);
            }
            catch
            {
                ErrorHandler.Report("Error reading float property from xml");
            }
            m_InitialValue = m_Value;
        }
        public override void Parse(XmlNode node)
        {
            base.Parse(node);
            System.Globalization.NumberFormatInfo nfi
                = System.Globalization.CultureInfo.InvariantCulture.NumberFormat;
            try
            {
                m_Value = float.Parse(node.Attributes.GetNamedItem("value").Value, nfi);
            }
            catch
            {
                ErrorHandler.Report("Error reading float property from xml");
            }
            m_InitialValue = m_Value;
        }
        public override void Reset()
        {
            m_Value = m_InitialValue;
        }
    }
}
