﻿/*
 * Copyright (C): Timo Fleisch
 *                2009 Berlin, Germany
 *                http://www.vrhome.de
 *                All Rights Reserved.
 *
 * THIS SOURCECODE IS PUBLISHED UNDER RESTRICTIONS.
 * No unauthorized copy or distribution allowed.
 * Please see website for detailed liscence information.
 * 
 */
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Tgex
{
    public class GlobalProperties
    {
        // create singleton
        static readonly GlobalProperties instance = new GlobalProperties();
        /// <summary>
        /// Get instance of singleton.
        /// </summary>
        public static GlobalProperties Instance
        {
            get
            {
                return instance;
            }
        }
        /// <summary>
        /// Explicit static constructor to tell C# compiler
        /// not to mark type as beforefieldinit
        /// </summary>
        static GlobalProperties()
        {
        }
        /// <summary>
        /// Constructor
        /// </summary>
        GlobalProperties()
        {
        }
        protected List<Property> propertyList = new List<Property>();
        public List<Property> PropertyList
        {
            get { return propertyList; }
            set { propertyList = value; }
        }
        public void AddProperty(Property property)
        {
            propertyList.Add(property);
        }
        public Property GetPropertyByName(String name)
        {
            foreach (Property property in propertyList)
            {
                if (property.Name == name)
                {
                    return property;
                }
            }
            return null;
        }

        /// <summary>
        /// Set all values to initial values
        /// </summary>
        public void Reset()
        {
            foreach (Property property in propertyList)
            {
                property.Reset();
            }
        }
    }
}
