/*
 * Copyright (C): Timo Fleisch
 *                2009 Berlin, Germany
 *                http://www.vrhome.de
 *                All Rights Reserved.
 *
 * THIS SOURCECODE IS PUBLISHED UNDER RESTRICTIONS.
 * No unauthorized copy or distribution allowed.
 * Please see website for detailed liscence information.
 * 
 */
using System;
using System.Collections.Generic;
using System.Text;
using System.Xml;

namespace Tgex
{
    public class IntProperty : Property
    {
        protected int m_Value;
        /// <summary>
        /// Int Value of property.
        /// </summary>
        public int Value
        {
            get { return m_Value; }
            set { m_Value = value; }
        }
        public override object GetValue()
        {
            return m_Value;
        }
        public override void SetValue(object v)
        {
            m_Value = (int)v;
        }
        protected int m_InitialValue;
        /// <summary>
        /// Value at start time
        /// </summary>
        public int InitialValue
        {
            get { return m_InitialValue; }
            set { m_InitialValue = value; }
        }

        public IntProperty()
        {
        }
        public IntProperty(IntProperty p)
            : base(p)
        {
            m_Value = p.Value;
            m_InitialValue = m_Value;
        }
        public override Property Clone()
        {
            return new IntProperty(this);
        }
        public IntProperty(XmlNode node)
            : base (node)
        {
            try
            {
                m_Value = Int32.Parse(node.Attributes.GetNamedItem("value").Value);
            }
            catch
            {
                ErrorHandler.Report("Error reading int property from xml");
            }
            m_InitialValue = m_Value;
        }
        public override void Parse(XmlNode node)
        {
            base.Parse(node);
            try
            {
                m_Value = Int32.Parse(node.Attributes.GetNamedItem("value").Value);
            }
            catch
            {
                ErrorHandler.Report("Error reading int property from xml");
            }
            m_InitialValue = m_Value;
        }
        public override void Reset()
        {
            m_Value = m_InitialValue;
        }
    }
}
