/*
 * Copyright (C): Timo Fleisch
 *                2009 Berlin, Germany
 *                http://www.vrhome.de
 *                All Rights Reserved.
 *
 * THIS SOURCECODE IS PUBLISHED UNDER RESTRICTIONS.
 * No unauthorized copy or distribution allowed.
 * Please see website for detailed liscence information.
 * 
 */
using System;
using System.Collections.Generic;
using System.Text;
using System.Xml;

namespace Tgex
{
    abstract public class Property
    {

        protected String name;
        /// <summary>
        /// Identifier name for property.
        /// </summary>
        public String Name
        {
            get { return name; }
            set { name = value; }
        }
        /// <summary>
        /// Constructor
        /// </summary>
        public Property()
        {
        }
        /// <summary>
        /// Copy constructor
        /// </summary>
        /// <param name="p"></param>
        public Property(Property p)
        {
            name = p.Name;
        }
        public Property(XmlNode node)
        {
            name = node.Attributes.GetNamedItem("name").Value;
        }
        public abstract Property Clone();
        /// <summary>
        /// Zune does not support Activator with Constructor paramenters
        /// </summary>
        /// <param name="node"></param>
        public virtual void Parse(XmlNode node)
        {
            name = node.Attributes.GetNamedItem("name").Value;
        }
        public virtual void Initialize()
        {
        }
        virtual public void Reset()
        {
        }

        public abstract object GetValue();
        public abstract void SetValue(object v);
    }
}
