/*
 * Copyright (C): Timo Fleisch
 *                2009 Berlin, Germany
 *                http://www.vrhome.de
 *                All Rights Reserved.
 *
 * THIS SOURCECODE IS PUBLISHED UNDER RESTRICTIONS.
 * No unauthorized copy or distribution allowed.
 * Please see website for detailed liscence information.
 * 
 */
using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.Xna.Framework;
using System.Xml;

namespace Tgex
{
    public class Vector2Property : Property
    {
        protected Vector2 m_Value;
        /// <summary>
        /// Vector2 m_Value of property.
        /// </summary>
        public Vector2 Value
        {
            get { return m_Value; }
            set { m_Value = value; }
        }
        public override object GetValue()
        {
            return m_Value;
        }
        public override void SetValue(object v)
        {
            m_Value = (Vector2)v;
        }
        protected Vector2 m_InitialValue;
        /// <summary>
        /// Value at start time.
        /// </summary>
        public Vector2 InitialValue
        {
            get { return m_InitialValue; }
            set { m_InitialValue = value; }
        }

        public Vector2Property()
        {
        }
        public Vector2Property(Vector2Property p)
            : base(p)
        {
            m_Value = p.Value;
            m_InitialValue = p.m_InitialValue;
        }
        public override Property Clone()
        {
            return new Vector2Property(this);
        }
        public Vector2Property(XmlNode node)
            : base(node)
        {
            m_Value = node.Attributes.GetNamedItem("value").Value.ParseVector2();
            m_InitialValue = m_Value;
        }
        public override void Parse(XmlNode node)
        {
            base.Parse(node);
            m_Value = node.Attributes.GetNamedItem("value").Value.ParseVector2();
            m_InitialValue = m_Value;
        }
        public override void Reset()
        {
            m_Value = m_InitialValue;
        }
    }
}
