/*
 * Copyright (C): Timo Fleisch
 *                2009 Berlin, Germany
 *                http://www.vrhome.de
 *                All Rights Reserved.
 *
 * THIS SOURCECODE IS PUBLISHED UNDER RESTRICTIONS.
 * No unauthorized copy or distribution allowed.
 * Please see website for detailed liscence information.
 * 
 */
using System;
using System.Collections.Generic;
using System.Text;

namespace Tgex
{
    public class SetPropertyAction : IAction
    {
        Property property;
        Object value;

        protected String m_Name;
        /// <summary>
        /// Name of action
        /// </summary>
        public String Name
        {
            get { return m_Name; }
            set { m_Name = value; }
        }

        public SetPropertyAction(Property property, Object value)
        {
            this.property = property;
            this.value = value;
        }
        public SetPropertyAction()
        {
        }
        public void AddParameter(InstanceParameter par)
        {
            if (par.type == typeof(Property))
            {
                property = (Property)par.value;
            }
            else
            {
                value = par.value;
            }
        }
        public void Execute()
        {
            property.SetValue(value);
        }
    }
}
