/*
 * Copyright (C): Timo Fleisch
 *                2009 Berlin, Germany
 *                http://www.vrhome.de
 *                All Rights Reserved.
 *
 * THIS SOURCECODE IS PUBLISHED UNDER RESTRICTIONS.
 * No unauthorized copy or distribution allowed.
 * Please see website for detailed liscence information.
 * 
 */
using System;
using System.Collections.Generic;
using System.Text;

namespace Tgex
{
    public class SwitchModuleAction : IAction
    {
        Module switchOffModule;
        Module switchOnModule;

        protected String m_Name;
        /// <summary>
        /// Name of action
        /// </summary>
        public String Name
        {
            get { return m_Name; }
            set { m_Name = value; }
        }
        
        public SwitchModuleAction(Module switchOffModule, Module switchOnModule)
        {
            this.switchOffModule = switchOffModule;
            this.switchOnModule = switchOnModule;
        }
        public SwitchModuleAction()
        {
        }
        public void AddParameter(InstanceParameter par)
        {
            switch (par.name)
            {
                case "switchOn":
                    switchOnModule = (Module)par.value;
                    break;
                case "switchOff":
                    switchOffModule = (Module)par.value;
                    break;
            }
        }
        public void Execute()
        {
            switchOffModule.Active = false;
            switchOnModule.Active = true;
        }
    }
}
