/*
 * Copyright (C): Timo Fleisch
 *                2009 Berlin, Germany
 *                http://www.vrhome.de
 *                All Rights Reserved.
 *
 * THIS SOURCECODE IS PUBLISHED UNDER RESTRICTIONS.
 * No unauthorized copy or distribution allowed.
 * Please see website for detailed liscence information.
 * 
 */
using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.Xna.Framework;

namespace Tgex
{
    public class Trigger
    {
        ICondition condition;
        List<IAction> actions = new List<IAction>();

        protected String name;
        /// <summary>
        /// Identifier name for modifier.
        /// </summary>
        public String Name
        {
            get { return name; }
            set { name = value; }
        }

        public void AddAction(IAction action)
        {
            actions.Add(action);
        }

        public void SetCondition(ICondition condition)
        {
            this.condition = condition;
        }

        protected bool repeat;
        /// <summary>
        /// True, if the trigger is reaccuring. If false, it will be deleted
        /// after triggert.
        /// </summary>
        public bool Repeat
        {
            get { return repeat; }
            set { repeat = value; }
        }

        private bool isDead;

        public bool IsDead
        {
            get { return isDead; }
            set { isDead = value; }
        }

        //protected Dynob dynob;

        public Trigger()
        {
            isDead = false;
            repeat = false;
        }

        public void Execute()
        {
            foreach (IAction action in actions)
            {
                action.Execute();
            }
        }

        public bool CheckCondition(GameTime time)
        {
            if (condition.CheckCondition())
            {
                Execute();
                if (!repeat)
                {
                    isDead = true;
                }
                return true;
            }
            return false;
        }

        public void Reset()
        {
            isDead = false;
        }

        //public void Register(Dynob dynob)
        //{
        //    this.dynob = dynob;
        //}
    }
}
