﻿/*
 * Copyright (C): Timo Fleisch
 *                2009 Berlin, Germany
 *                http://www.vrhome.de
 *                All Rights Reserved.
 *
 * THIS SOURCECODE IS PUBLISHED UNDER RESTRICTIONS.
 * No unauthorized copy or distribution allowed.
 * Please see website for detailed liscence information.
 * 
 */
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Tvrx
{
    public enum ColorMode
    {
        YUV444,
        YUV422,
        YUV411,
        RGB,
        Y8,
        Y16
    }

    public class CaptureCameraDesc
    {
        public string id;
        public string model;

        public bool flipImage;

        public int width;
        public int height;
        public ColorMode colorMode;

        public float focalLengthX;
        public float focalLengthY;

        // size of a pixel on the sensor in mm
        public float pixelSize;
        // distortion coeffs
        public float k1, k2, p1, p2;
        // principal point
        public float principalPointX;
        public float principalPointY;

        public void SetColorMode(String mode)
        {
            switch (mode)
            {
                case "YUV444":
                    colorMode = ColorMode.YUV444;
                    break;
                case "YUV422":
                    colorMode = ColorMode.YUV422;
                    break;
                case "YUV411":
                    colorMode = ColorMode.YUV411;
                    break;
                case "RGB":
                    colorMode = ColorMode.RGB;
                    break;
                case "Y8":
                    colorMode = ColorMode.Y8;
                    break;
                case "Y16":
                    colorMode = ColorMode.Y16;
                    break;
                default:
                    colorMode = ColorMode.Y8;
                    break;
            }
        }
    }

    public struct CaptureCameraSettings
    {
        public int exposure;
        public int brightness;
        public int gain;
        public int shutter;
    }
}
