﻿/*
 * Copyright (C): Timo Fleisch
 *                2009 Berlin, Germany
 *                http://www.vrhome.de
 *                All Rights Reserved.
 *
 * THIS SOURCECODE IS PUBLISHED UNDER RESTRICTIONS.
 * No unauthorized copy or distribution allowed.
 * Please see website for detailed liscence information.
 * 
 */
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Tvrx
{
    public class AverageFilter : IDataFilter
    {
        int m_numOfValues;
        Queue<float> m_valueQueue;
        float m_sum = 0;
        public void SetFilterDesc(DataFilterDesc desc)
        {
            m_numOfValues = ((AverageFilterDesc)desc).numOfValues;
            m_valueQueue = new Queue<float>();
            m_sum = 0;
        }
        public float Filter(float inData)
        {
            if ((!float.IsInfinity(inData)) && (!float.IsNaN(inData)))
            {
                if (m_numOfValues == m_valueQueue.Count)
                {
                    m_sum -= m_valueQueue.Dequeue();
                }
                m_sum += inData;
                m_valueQueue.Enqueue(inData);
                return m_sum / (float)m_valueQueue.Count;
            }
            return 0;
        }
    }
}
