﻿/*
 * Copyright (C): Timo Fleisch
 *                2009 Berlin, Germany
 *                http://www.vrhome.de
 *                All Rights Reserved.
 *
 * THIS SOURCECODE IS PUBLISHED UNDER RESTRICTIONS.
 * No unauthorized copy or distribution allowed.
 * Please see website for detailed liscence information.
 * 
 */
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework;

namespace Tvrx
{
    public interface IPoseEstimate
    {
        void InitializeCameraParameter(double focalLengthMM, bool flipImage, float scale, 
            int[] assignAxis, int[] assignAxisSign);
        void InitializeMarkerBody(Vector3[] markerPoints);
        void UpdateImagePoints(Vector2[] imagePoints);
        void GetTransform(out Vector3 position, out Vector3 rotation);
        void StartEstimation();
        void StopEstimation();
    }
}
