﻿/*
 * Copyright (C): Timo Fleisch
 *                2009 Berlin, Germany
 *                http://www.vrhome.de
 *                All Rights Reserved.
 *
 * THIS SOURCECODE IS PUBLISHED UNDER RESTRICTIONS.
 * No unauthorized copy or distribution allowed.
 * Please see website for detailed liscence information.
 * 
 */
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework;

namespace Tvrx
{
    public class MarkerBodyDesc
    {
        protected List<Vector3> m_WorldMarker = new List<Vector3>();
        /// <summary>
        /// List of markers in real world coordinates of
        /// the tracking device.
        /// </summary>
        public List<Vector3> WorldMarker
        {
            get { return m_WorldMarker; }
            set { m_WorldMarker = value; }
        }
        private int m_Id;
        /// <summary>
        /// Id of this marker device
        /// </summary>
        public int Id
        {
            get { return m_Id; }
            set { m_Id = value; }
        }
        protected String m_Name;
        /// <summary>
        /// Help
        /// </summary>
        public String Name
        {
            get { return m_Name; }
            set { m_Name = value; }
        }
        protected float m_NearClip;
        /// <summary>
        /// Minimal distance to camera to start clipping in mm.
        /// </summary>
        public float NearClip
        {
            get { return m_NearClip; }
            set { m_NearClip = value; }
        }
        protected float m_FarClip;
        /// <summary>
        /// Maximum distance to camera to start clipping in mm.
        /// </summary>
        public float FarClip
        {
            get { return m_FarClip; }
            set { m_FarClip = value; }
        }
    }
}
