﻿/*
 * Copyright (C): Timo Fleisch
 *                2009 Berlin, Germany
 *                http://www.vrhome.de
 *                All Rights Reserved.
 *
 * THIS SOURCECODE IS PUBLISHED UNDER RESTRICTIONS.
 * No unauthorized copy or distribution allowed.
 * Please see website for detailed liscence information.
 * 
 */
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework;

namespace Tvrx
{
    public class MarkerTrackerDesc
    {
        protected int m_Id = 0;
        /// <summary>
        /// Id of TCam tracker.
        /// </summary>
        public int Id
        {
            get { return m_Id; }
            set { m_Id = value; }
        }
        protected String m_CameraModel;
        /// <summary>
        /// Name of camera model to match with right camera from cameras.xml
        /// </summary>
        public String CameraModel
        {
            get { return m_CameraModel; }
            set { m_CameraModel = value; }
        }
        protected Vector3 m_Translation = new Vector3();
        /// <summary>
        /// Translation of camera.
        /// </summary>
        public Vector3 Translation
        {
            get { return m_Translation; }
            set { m_Translation = value; }
        }
        protected Vector3 m_Rotation = new Vector3();
        /// <summary>
        /// Rotation of camera.
        /// </summary>
        public Vector3 Rotation
        {
            get { return m_Rotation; }
            set { m_Rotation = value; }
        }
        protected float m_Scale = 1.0f;
        /// <summary>
        /// Scale from camera metric to directx metric.
        /// </summary>
        public float Scale
        {
            get { return m_Scale; }
            set { m_Scale = value; }
        }
        protected String m_XAxis = "x";
        /// <summary>
        /// Rematch x axis of tracking camera to directx axis.
        /// </summary>
        public String XAxis
        {
            get { return m_XAxis; }
            set { m_XAxis = value; }
        }
        protected String m_YAxis = "y";
        /// <summary>
        /// Rematch y axis of tracking camera to directx axis.
        /// </summary>
        public String YAxis
        {
            get { return m_YAxis; }
            set { m_YAxis = value; }
        }
        protected String m_ZAxis = "z";
        /// <summary>
        /// Rematch z axis of tracking camera to directx axis.
        /// </summary>
        public String ZAxis
        {
            get { return m_ZAxis; }
            set { m_ZAxis = value; }
        }
    }
}
