﻿/*
 * Copyright (C): Timo Fleisch
 *                2009 Berlin, Germany
 *                http://www.vrhome.de
 *                All Rights Reserved.
 *
 * THIS SOURCECODE IS PUBLISHED UNDER RESTRICTIONS.
 * No unauthorized copy or distribution allowed.
 * Please see website for detailed liscence information.
 * 
 */
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework;

namespace Tvrx
{
    public class TCamMarkerBodyDesc : MarkerBodyDesc
    {
        #region data defining the body
        protected float m_BarLength;
        /// <summary>
        /// Length of 3 marker line in mm.
        /// </summary>
        public float BarLength
        {
            get { return m_BarLength; }
            set { m_BarLength = value; }
        }
        protected float m_IdMarker;
        /// <summary>
        /// Normalized position on 3 marker line (bar) of id marker in mm.
        /// </summary>
        public float IdMarker
        {
            get { return m_IdMarker; }
            set { m_IdMarker = value; }
        }
        protected float m_CrossPoint;
        /// <summary>
        /// Point on 3 marker line, where the line of remaing two points intersects.
        /// </summary>
        public float CrossPoint
        {
            get { return m_CrossPoint; }
            set { m_CrossPoint = value; }
        }
        #endregion

        #region for recognition algorithm
        protected bool m_BarRecognized;
        /// <summary>
        /// For finding bar alogrithm
        /// </summary>
        public bool BarRecognized
        {
            get { return m_BarRecognized; }
            set { m_BarRecognized = value; }
        }
        protected Vector2 m_StartLinePoint;
        /// <summary>
        /// Starting point of recognized 3 marker line
        /// </summary>
        public Vector2 StartLinePoint
        {
            get { return m_StartLinePoint; }
            set { m_StartLinePoint = value; }
        }
        protected Vector2 m_EndLinePoint;
        /// <summary>
        /// End point of recognized 3 marker line
        /// </summary>
        public Vector2 EndLinePoint
        {
            get { return m_EndLinePoint; }
            set { m_EndLinePoint = value; }
        }
        protected Vector2 m_IdPoint;
        /// <summary>
        /// Middle point of 3 marker line
        /// </summary>
        public Vector2 IdPoint
        {
            get { return m_IdPoint; }
            set { m_IdPoint = value; }
        }
        protected bool m_MarkerRecognized;
        /// <summary>
        /// True if the marker has been recognized.
        /// </summary>
        public bool MarkerRecognized
        {
            get { return m_MarkerRecognized; }
            set { m_MarkerRecognized = value; }
        }

        #endregion


    }
}
