﻿/*
 * Copyright (C): Timo Fleisch
 *                2009 Berlin, Germany
 *                http://www.vrhome.de
 *                All Rights Reserved.
 *
 * THIS SOURCECODE IS PUBLISHED UNDER RESTRICTIONS.
 * No unauthorized copy or distribution allowed.
 * Please see website for detailed liscence information.
 * 
 */
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework;

namespace Tvrx
{
    public class TrackedDeviceDesc
    {
        protected int m_Id;
        /// <summary>
        /// Id of tracked device.
        /// </summary>
        public int Id
        {
            get { return m_Id; }
            set { m_Id = value; }
        }
        protected int m_TrackerCamId;
        /// <summary>
        /// Id of associated marker tracker (camera).
        /// </summary>
        public int TrackerCamId
        {
            get { return m_TrackerCamId; }
            set { m_TrackerCamId = value; }
        }

        protected bool m_HasTranslation;
        /// <summary>
        /// True if tracker tracks translation.
        /// </summary>
        public bool HasTranslation
        {
            get { return m_HasTranslation; }
            set { m_HasTranslation = value; }
        }
        protected bool m_HasRotation;
        /// <summary>
        /// True if tracker has rotation.
        /// </summary>
        public bool HasRotation
        {
            get { return m_HasRotation; }
            set { m_HasRotation = value; }
        }
        protected Vector3 m_LocalTranslation;
        /// <summary>
        /// Translation of local marker reference coordinate system (zero marker).
        /// </summary>
        public Vector3 LocalTranslation
        {
            get { return m_LocalTranslation; }
            set { m_LocalTranslation = value; }
        }
        protected Vector3 m_LocalRotation;
        /// <summary>
        /// Euler rotation  of local marker reference coordinate system (zero marker).
        /// </summary>
        public Vector3 LocalRotation
        {
            get { return m_LocalRotation; }
            set { m_LocalRotation = value; }
        }
        protected Vector3 m_WorldTranslation;
        /// <summary>
        /// Translation of marker in world coordinate system.
        /// </summary>
        public Vector3 WorldTranslation
        {
            get { return m_WorldTranslation; }
            set { m_WorldTranslation = value; }
        }
        protected Vector3 m_WorldRotation;
        /// <summary>
        /// Euler rotation of marker in world coordinate system.
        /// </summary>
        public Vector3 WorldRotation
        {
            get { return m_WorldRotation; }
            set { m_WorldRotation = value; }
        }
        protected int m_TranslationFilterId;
        /// <summary>
        /// Id of filter to use for translation.
        /// </summary>
        public int TranslationFilterId
        {
            get { return m_TranslationFilterId; }
            set { m_TranslationFilterId = value; }
        }
        protected int m_RotationFilterId;
        /// <summary>
        /// Id of filter to use for Rotation.
        /// </summary>
        public int RotationFilterId
        {
            get { return m_RotationFilterId; }
            set { m_RotationFilterId = value; }
        }
        protected bool[] m_ReverseTranslation = new bool[3] {false, false, false};
        /// <summary>
        /// True if an axis direction has to be reversed.
        /// </summary>
        public bool[] ReverseTranslation
        {
            get { return m_ReverseTranslation; }
            set { m_ReverseTranslation = value; }
        }
        protected bool[] m_ReverseRotation = new bool[3] { false, false, false };
        /// <summary>
        /// True if an axis rotation has to be reversed.
        /// </summary>
        public bool[] ReverseRotation
        {
            get { return m_ReverseRotation; }
            set { m_ReverseRotation = value; }
        }
    }
}
