﻿/*
 * Copyright (C): Timo Fleisch
 *                2009 Berlin, Germany
 *                http://www.vrhome.de
 *                All Rights Reserved.
 *
 * THIS SOURCECODE IS PUBLISHED UNDER RESTRICTIONS.
 * No unauthorized copy or distribution allowed.
 * Please see website for detailed liscence information.
 * 
 */
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework;

namespace Tvrx
{
    public class TrackedMarker : TrackedDevice
    {
        TCamTracker m_tracker; // = new TCamTracker();
        TCamMarkerBodyDesc m_markerBody;

        public override void Initialize() 
        {
            //m_tracker.Initialize();
            m_poseEstimate = new Posit();
        }
        public void SetTracker(TCamTracker tracker)
        {
            m_tracker = tracker;
        }
        public void SetMarkerBody(TCamMarkerBodyDesc markerBody)
        {
            m_markerBody = markerBody;
            Vector3[] markerPoints = new Vector3[markerBody.WorldMarker.Count];
            for (int i = 0; i < markerBody.WorldMarker.Count; i++)
            {
                markerPoints[i] = markerBody.WorldMarker[i];
            }
            m_poseEstimate.InitializeMarkerBody(markerPoints);
            m_tracker.RegisterMarkerBody(m_markerBody, m_poseEstimate);
        }
        /// <summary>
        /// This starts a new thread that continously tracks the device
        /// </summary>
        public override void StartTracking() 
        {
            m_tracker.StartTracking();
            m_poseEstimate.StartEstimation();
            base.StartTracking();
        }
        public override void StopTracking() 
        {
            m_tracker.StopTracking();
            m_poseEstimate.StopEstimation();
            base.StopTracking();
        }

        public override void Filter() 
        {
            base.Filter();
        }
    }
}
