﻿/*
 * Copyright (C): Timo Fleisch
 *                2009 Berlin, Germany
 *                http://www.vrhome.de
 *                All Rights Reserved.
 *
 * THIS SOURCECODE IS PUBLISHED UNDER RESTRICTIONS.
 * No unauthorized copy or distribution allowed.
 * Please see website for detailed liscence information.
 * 
 */
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework;

namespace Tvrx
{
    public class TrackedWiiMote : TrackedDevice
    {
        WiiMoteTracker m_tracker;

        MarkerBodyDesc m_markerBodyDesc;

        public override void Initialize()
        {
            //m_tracker.Initialize();
            m_poseEstimate = new Posit();
            //m_translationFilter = new KalmanFilter[3];
            //m_rotationFilter = new KalmanFilter[3];
            //KalmanFilterDesc desc = new KalmanFilterDesc();
            //desc.A = new float[] { 1, 0.005f, 0, 1 };
            //desc.measurement_noise_cov = 1.0f;
            //desc.process_noise_cov_1 = 0.0000001f;
            //desc.process_noise_cov_2 = 0.0000001f;
            //for (int i = 0; i < 3; i++)
            //{
            //    m_translationFilter[i] = new KalmanFilter();
            //    m_translationFilter[i].SetFilterDesc(desc);
            //    m_rotationFilter[i] = new KalmanFilter();
            //    m_rotationFilter[i].SetFilterDesc(desc);
            //    m_reverseRotation[i] = false;
            //    m_reverseTranslation[i] = false;
            //}
            //m_reverseTranslation[2] = true;
            //m_reverseRotation[1] = true;
        }
        public void SetTracker(WiiMoteTracker tracker)
        {
            m_tracker = tracker;
        }
        public void SetMarkerBody(MarkerBodyDesc markerBody)
        {
            m_markerBodyDesc = markerBody;
            Vector3[] markerPoints = new Vector3[markerBody.WorldMarker.Count];
            for (int i = 0; i < markerBody.WorldMarker.Count; i++)
            {
                markerPoints[i] = markerBody.WorldMarker[i];
            }
            m_poseEstimate.InitializeMarkerBody(markerPoints);
            m_tracker.RegisterMarkerBody(m_markerBodyDesc, m_poseEstimate);
        }
        /// <summary>
        /// This starts a new thread that continously tracks the device
        /// </summary>
        public override void StartTracking()
        {
            m_tracker.StartTracking();
            m_poseEstimate.StartEstimation();
            base.StartTracking();
        }
        public override void StopTracking()
        {
            m_tracker.StopTracking();
            m_poseEstimate.StopEstimation();
            base.StopTracking();
        }
        public override void TransformToVirtualSpace()
        {
            // reset tracker rotation according to wiimote rotation read from accelerators
            Vector3 scale, translation;
            Quaternion rotation;
            m_TrackerWorldTransform.Decompose(out scale, out rotation, out translation);
            m_TrackerWorldTransform =
                    Matrix.CreateFromYawPitchRoll(m_tracker.Rotation.Y, m_tracker.Rotation.X, m_tracker.Rotation.Z)
                    * Matrix.CreateTranslation(translation);
                    //* Matrix.CreateScale(scale);
            base.TransformToVirtualSpace();
        }
    }
}
