﻿/*
 * Copyright (C): Timo Fleisch
 *                2009 Berlin, Germany
 *                http://www.vrhome.de
 *                All Rights Reserved.
 *
 * THIS SOURCECODE IS PUBLISHED UNDER RESTRICTIONS.
 * No unauthorized copy or distribution allowed.
 * Please see website for detailed liscence information.
 * 
 */
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework;

namespace Tvrx
{
    public class TrackerProxy
    {
        protected int m_Id;
        /// <summary>
        /// Id of proxy element.
        /// </summary>
        public int Id
        {
            get { return m_Id; }
            set { m_Id = value; }
        }
        protected List<TrackedDevice> m_TranslationDevices = new List<TrackedDevice>();
        /// <summary>
        /// Device that tracks the translation.
        /// </summary>
        public List<TrackedDevice> TranslationDevices
        {
            get { return m_TranslationDevices; }
        }
        protected List<TrackedDevice> m_RotationDevices = new List<TrackedDevice>();
        /// <summary>
        /// Device that tracks the rotation.
        /// </summary>
        public List<TrackedDevice> RotationDevices
        {
            get { return m_RotationDevices; }
        }
        public Matrix GetTransform()
        {

            // just get transforms of first element by now
            // extend to multiple devices later (camera arrays)
            if ((m_RotationDevices.Count > 0) && (m_TranslationDevices.Count > 0))
            {
                return Matrix.CreateFromQuaternion(m_RotationDevices[0].Rotation)
                    * Matrix.CreateTranslation(m_TranslationDevices[0].Translation);
            }
            return Matrix.Identity;
        }

    }
}
