; vrdesktop.nsi
;

;--------------------------------

; The name of the installer
Name "VRDesktop"

; The file to write
OutFile "vrdesktopsetup.exe"

; The default installation directory
InstallDir $PROGRAMFILES\VRhome\vrdesktop

; Registry key to check for directory (so if you install again, it will 
; overwrite the old one automatically)
InstallDirRegKey HKLM "Software\VRhome_VRDesktop" "Install_Dir"

; Request application privileges for Windows Vista
RequestExecutionLevel admin

;--------------------------------

; Pages

Page components
Page directory
Page instfiles

UninstPage uninstConfirm
UninstPage instfiles

;--------------------------------


; The stuff to install
Section "VRDesktop (required)"

  SectionIn RO
  
  ; Set output path to the installation directory.
  SetOutPath $INSTDIR
  
  ; Put file there
  File "..\VRDesktopDemo\bin\x86\Release\*.dll"
  File "..\VRDesktopDemo\bin\x86\Release\*.exe"
  File "..\VRDesktopDemo\bin\x86\Release\*.xml"
  File "..\ExtLibs\OpenCV\opencvlib\*"
  SetOutPath $INSTDIR\Content
  File "..\VRDesktopDemo\bin\x86\Release\Content\*"
  SetOutPath $INSTDIR\Content\shader
  File "..\VRDesktopDemo\bin\x86\Release\Content\shader\*"
  SetOutPath $INSTDIR\Config
  File "..\VRDesktopDemo\bin\x86\Release\Config\*"
  SetOutPath $INSTDIR
  
  ; Write the installation path into the registry
  WriteRegStr HKLM SOFTWARE\VRhome_VRDesktop "Install_Dir" "$INSTDIR"
  
  ; Write the uninstall keys for Windows
  WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\VRDesktop" "DisplayName" "VRDesktop"
  WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\VRDesktop" "UninstallString" '"$INSTDIR\uninstall.exe"'
  WriteRegDWORD HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\VRDesktop" "NoModify" 1
  WriteRegDWORD HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\VRDesktop" "NoRepair" 1
  WriteUninstaller "uninstall.exe"
  
SectionEnd

; These are the programs that are needed by xna game
Section "Microsoft XNA 3.0  Redistributable"
  SetOutPath $INSTDIR\Prerequisites
	File "C:\Program Files\Microsoft XNA\XNA Game Studio\v3.0\Redist\XNA FX Redist\xnafx30_redist.msi"
	ExecWait '"msiexec" /i "$INSTDIR\Prerequisites\xnafx30_redist.msi"'
SectionEnd

Section "Microsoft DirectX 9.c Redistributable"
  SetOutPath $INSTDIR\Prerequisites
    File "C:\Program Files\Microsoft XNA\XNA Game Studio\v3.0\Redist\DX Redist\*"
    ExecWait '"$INSTDIR\Prerequisites\DXSETUP.exe"'
SectionEnd

; Optional section (can be disabled by the user)
Section "Start Menu Shortcuts"

  SetOutPath $INSTDIR
  CreateDirectory "$SMPROGRAMS\VRDesktop"
  CreateShortCut "$SMPROGRAMS\VRDesktop\Uninstall.lnk" "$INSTDIR\uninstall.exe" "" "$INSTDIR\uninstall.exe" 0
  CreateShortCut "$SMPROGRAMS\VRDesktop\VRDesktop.lnk" "$INSTDIR\VRDesktopDemo.exe" "" "$INSTDIR\VRDesktopDemo.exe" 0
  
SectionEnd

;--------------------------------

; Uninstaller

Section "Uninstall"
  
  ; Remove registry keys
  DeleteRegKey HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\VRDesktop"
  DeleteRegKey HKLM SOFTWARE\VRhome_VRDesktop

  ; Remove files and uninstaller
  Delete $INSTDIR\*.*
  Delete $INSTDIR\Config\*.*
  Delete $INSTDIR\Content\*.*
  Delete $INSTDIR\Content\shader\*.*
  Delete $INSTDIR\Prerequisites\*.*

  ; Remove shortcuts, if any
  Delete "$SMPROGRAMS\VRDesktop\*.*"

  ; Remove directories used
  RMDir "$SMPROGRAMS\VRDesktop"
  RMDir "$INSTDIR\Prerequisites"
  RMDir "$INSTDIR\Content\shader"
  RMDir "$INSTDIR\Content"
  RMDir "$INSTDIR\Config"
  RMDir "$INSTDIR"

SectionEnd
